Skip to main content
POST
/
exchange
Transfer USDC
curl --request POST \
  --url https://api.hyperliquid.xyz/exchange \
  --header 'Content-Type: application/json' \
  --data '
{
  "action": {
    "type": "usdSend",
    "hyperliquidChain": "Mainnet",
    "signatureChainId": "0xa4b1",
    "destination": "0x1234567890abcdef1234567890abcdef12345678",
    "amount": "100.0",
    "time": 1705234567890
  },
  "nonce": 1705234567890,
  "signature": {
    "r": "0x0000000000000000000000000000000000000000000000000000000000000000",
    "s": "0x0000000000000000000000000000000000000000000000000000000000000000",
    "v": 27
  },
  "vaultAddress": null
}
'
import requests

url = "https://api.hyperliquid.xyz/exchange"

payload = {
"action": {
"type": "usdSend",
"hyperliquidChain": "Mainnet",
"signatureChainId": "0xa4b1",
"destination": "0x1234567890abcdef1234567890abcdef12345678",
"amount": "100.0",
"time": 1705234567890
},
"nonce": 1705234567890,
"signature": {
"r": "0x0000000000000000000000000000000000000000000000000000000000000000",
"s": "0x0000000000000000000000000000000000000000000000000000000000000000",
"v": 27
},
"vaultAddress": None
}
headers = {"Content-Type": "application/json"}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
const options = {
method: 'POST',
headers: {'Content-Type': 'application/json'},
body: JSON.stringify({
action: {
type: 'usdSend',
hyperliquidChain: 'Mainnet',
signatureChainId: '0xa4b1',
destination: '0x1234567890abcdef1234567890abcdef12345678',
amount: '100.0',
time: 1705234567890
},
nonce: 1705234567890,
signature: {
r: '0x0000000000000000000000000000000000000000000000000000000000000000',
s: '0x0000000000000000000000000000000000000000000000000000000000000000',
v: 27
},
vaultAddress: null
})
};

fetch('https://api.hyperliquid.xyz/exchange', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));


{
  "status": "ok",
  "response": {
    "type": "usdSend",
    "data": {
      "status": "success"
    }
  }
}
You can only use this endpoint on the official Hyperliquid public API. It is not available through Chainstack, as the open-source node implementation does not support it yet. See Hyperliquid methods for the full availability breakdown.
This endpoint requires signature authentication. See our comprehensive Authentication via Signatures guide for implementation details.
Transfers USDC directly to another address on the Hyperliquid chain. This is an internal transfer that doesn’t interact with the EVM bridge and uses a human-readable signature format for wallet interfaces.
Get your own node endpoint todayStart for free and get your app to production levels immediately. No credit card required.You can sign up with your GitHub, X, Google, or Microsoft account.

Parameters

Required parameters

  • action (object, required) — The USD send action object containing:
    • type (string) — Must be "usdSend"
    • hyperliquidChain (string) — "Mainnet" for mainnet, "Testnet" for testnet
    • signatureChainId (string) — Chain ID used for signing in hex format (e.g., "0xa4b1" for Arbitrum)
    • destination (string) — Recipient address in 42-character hexadecimal format
    • amount (string) — Amount of USDC to send (e.g., "100.5" for 100.5 USDC)
    • time (number) — Current timestamp in milliseconds (must match nonce)
  • nonce (number, required) — Current timestamp in milliseconds (must match action.time)
  • signature (object, required) — EIP-712 signature of the action

Signature format

This endpoint uses EIP-712 typed data signing with a human-readable format:
{
  "types": {
    "HyperliquidTransaction:UsdSend": [
      {"name": "hyperliquidChain", "type": "string"},
      {"name": "destination", "type": "string"},
      {"name": "amount", "type": "string"},
      {"name": "time", "type": "uint64"}
    ]
  },
  "primaryType": "HyperliquidTransaction:UsdSend",
  "domain": {
    "name": "HyperliquidSignTransaction",
    "version": "1",
    "chainId": 42161,
    "verifyingContract": "0x0000000000000000000000000000000000000000"
  },
  "message": {
    "hyperliquidChain": "Mainnet",
    "destination": "0x...",
    "amount": "100.5",
    "time": 1234567890123
  }
}

Returns

Returns an object with transfer status:
  • status"ok" if successful
  • response — Contains transfer details:
    • type"default"

Example request

curl -X POST https://api.hyperliquid.xyz/exchange \
  -H "Content-Type: application/json" \
  -d '{
    "action": {
      "type": "usdSend",
      "hyperliquidChain": "Mainnet",
      "signatureChainId": "0xa4b1",
      "destination": "0x742d35Cc6634C0532925a3b844Bc9e7595f0bEb0",
      "amount": "100.5",
      "time": 1234567890123
    },
    "nonce": 1234567890123,
    "signature": {...}
  }'
from hyperliquid.exchange import Exchange
from hyperliquid.utils import constants
import eth_account

# Initialize with your private key
account = eth_account.Account.from_key("0x...")
exchange = Exchange(account, constants.MAINNET_API_URL)

# Send 100.5 USDC to another address
transfer_result = exchange.usd_transfer(
    amount=100.5,
    destination="0x742d35Cc6634C0532925a3b844Bc9e7595f0bEb0",
)

print(transfer_result)
import { ExchangeClient, HttpTransport } from "@nktkas/hyperliquid";
import { privateKeyToAccount } from "viem/accounts";

// Initialize with your private key
const wallet = privateKeyToAccount("0x...");
const transport = new HttpTransport();
const exchange = new ExchangeClient({ transport, wallet });

// Send 100.5 USDC to another address
const transferResult = await exchange.usdSend({
  destination: "0x742d35Cc6634C0532925a3b844Bc9e7595f0bEb0",
  amount: "100.5",
});

console.log(transferResult);

Response example

{
  "status": "ok",
  "response": {
    "type": "default"
  }
}

Important notes

  • Internal transfers only — This doesn’t interact with external bridges
  • Instant settlement — Transfers are immediate within Hyperliquid
  • No gas fees — Internal transfers don’t require gas
  • Decimal precision — Amount is a string to preserve decimal precision

Use cases

  • P2P transfers — Send USDC directly to other users
  • Account funding — Transfer between your own accounts
  • Payment processing — Programmatic USDC payments
  • Vault operations — Transfer funds to/from vault addresses
The time parameter in the action must exactly match the nonce parameter. This ensures signature uniqueness and prevents replay attacks.
Always verify the destination address. Transfers are irreversible once confirmed on the Hyperliquid chain.

Body

application/json
action
object
required
nonce
integer
required

Current timestamp in milliseconds

signature
object
required

EIP-712 signature of the action with r, s, v components

vaultAddress
string | null

Address when trading on behalf of a vault or subaccount (optional)

Response

200 - application/json

USDC transfer result

status
string

Request status

response
object
Last modified on July 7, 2026